//+------------------------------------------------------------------+
//|                                   Copyright  2010, Ivan Kornilov|
//|                                                 indicators\MA.mqh|
//|                                   excelf@gmail.com, skype: excelf|
//+------------------------------------------------------------------+
/*

#include <indicators\indiUtils.mqh>
#include <indicators\MA.mqh>
#include <indicators\Regression.mqh>
//*/

int ma.maPrice = PRICE_CLOSE;
int ma.maType = 0;
int ma.SSLshift = 1;
int ma.oldSignal = SIGNAL_NONE;

int ma.getMaCrossSignal(int maPeriod1,int maPeriod2 , int tf, int shift = 0) {   
    double maFast = iMA(NULL, tf, maPeriod1, 0, ma.maType, ma.maPrice, shift);
    double maSlow = iMA(NULL, tf, maPeriod2, 0, ma.maType, ma.maPrice, shift);
    
    int signal = 0;   
    if (maFast > maSlow) {
        signal = SIGNAL_BUY;
    } else { 
        signal = SIGNAL_SELL; 
    }
    return(signal);
}

int ma.getMaByMaSignal(int maPeriod, int maByma, int tf = 0, int shift = 0) {  
    double maFast = iMA(NULL, tf, maPeriod, 0, ma.maType, ma.maPrice, shift);
    double maSlow = ma.getMaByMaValue(maFast, maByma, tf, shift);   
    
    int signal = 0;   
    if (maFast > maSlow) {
        signal = SIGNAL_BUY;
    } else { 
        signal = SIGNAL_SELL; 
    }
    return(signal);
}



datetime ma.maArrayLastTime = 0;
double ma.maArray[];
double ma.getMaByMaValue(double maNow, int maPeriod, int maByma, int tf, int shift = 0) {   
    if(!ArrayIsSeries(ma.maArray)) {
      ArraySetAsSeries(ma.maArray, true);
    }
    int maArraySize = ArraySize(ma.maArray);
    if(maArraySize != maByma) {
        maArraySize = ArrayResize(ma.maArray, maByma);
    }

    int i;
    datetime time = iTime(NULL, tf, shift);
    ma.maArray[0] = maNow;
    if(ma.maArrayLastTime != time) {
        if(time - ma.maArrayLastTime == tf * SECOND_IN_MINUT) {
            for(i = maArraySize - 1; i > 0; i--) {
                ma.maArray[i] = ma.maArray[i - 1];
            }
        } else {
            for(i = maArraySize - 1; i > 0; i--) {
                ma.maArray[i] = iMA(NULL, tf, maPeriod, 0, ma.maType, ma.maPrice, i + shift);
            }   
        }
        ma.maArrayLastTime = time;
    } 
    return(iMAOnArray(ma.maArray, 0, maByma, 0,  ma.maType, 0));
}

int ma.getSSLSignal(int params[], int tf, int shift) {   
    int slow = params[1];
    double ma1 = iMA(NULL, tf, slow, 0, ma.maType, PRICE_HIGH, shift + ma.SSLshift);
    double ma2 = iMA(NULL, tf, slow, 0, ma.maType, PRICE_LOW, shift + ma.SSLshift);
    int signal = SIGNAL_NONE;  
    
    
    signal = ma.oldSignal;
    if (Close[shift] > ma1) {
        signal = SIGNAL_BUY;
    } else if (Close[shift] < ma2) {
        signal = SIGNAL_SELL; 
    }
    ma.oldSignal = signal;
    return(signal);
}

int ma.div = 1;
int ma.getDidiSignal(int params[], int tf, int shift) {   
  
    int ma1 = params[0];
    int ma2 = params[1];
    int ma3 = (params[0] + params[1]) * ma.div;
    
    double ma1Value = iMA(NULL, 0, ma1, 0, ma.maType, PRICE_CLOSE, shift);
    double ma2Value = iMA(NULL, 0, ma2, 0, ma.maType, PRICE_CLOSE, shift);
    double ma3Value = iMA(NULL, 0, ma3, 0, ma.maType, PRICE_CLOSE, shift);
    
    double maFast = ma1Value - ma2Value;
    double maSlow = ma3Value - ma2Value;
    
    int signal = SIGNAL_NONE;   
    if (maFast > maSlow) {
        signal = SIGNAL_BUY;
    } else { 
        signal = SIGNAL_SELL; 
    }
    return(signal);
}

#define BUFFER_SIZE 0
#define SIZE_STEP   10000

double MaBuffer1[BUFFER_SIZE];
double MaBuffer2[BUFFER_SIZE];
double MaBuffer3[BUFFER_SIZE];
double MaBuffer4[BUFFER_SIZE];
int ma.maBufferSize = BUFFER_SIZE; 
double ma.getMacdValue(int maPeriod1, int maPeriod2, int tf, int shift = 0) {
    if(!ArrayIsSeries(MaBuffer1)) {
      ArraySetAsSeries(MaBuffer1, true);
      ArraySetAsSeries(MaBuffer2, true);
      ArraySetAsSeries(MaBuffer3, true);
      ArraySetAsSeries(MaBuffer4, true);
    }

    if(ma.maBufferSize < Bars) {
      int step = SIZE_STEP;
      if(Bars - ma.maBufferSize > SIZE_STEP) {
         step = SIZE_STEP + Bars - ma.maBufferSize;
      }
      Print("Resize: was=" + ma.maBufferSize + " be=" + (ma.maBufferSize + step));
      ma.maBufferSize = ma.maBufferSize + step;
      indiUtils.resizeArray(ma.maBufferSize, MaBuffer1);
      indiUtils.resizeArray(ma.maBufferSize, MaBuffer2);
      indiUtils.resizeArray(ma.maBufferSize, MaBuffer3);
      indiUtils.resizeArray(ma.maBufferSize, MaBuffer4);
    }
    
    indiUtils.setManualBuffer(MaBuffer1, iMA(NULL, tf, maPeriod1, 0, ma.maType, ma.maPrice, shift), shift);
    indiUtils.setManualBuffer(MaBuffer2, indiUtils.getManualBuffer(MaBuffer1, shift) - iMAOnArray(MaBuffer1, 0, maPeriod2, 0, 0, Bars - shift - maPeriod2), shift);  
    indiUtils.setManualBuffer(MaBuffer3, indiUtils.getManualBuffer(MaBuffer2, shift) - iMAOnArray(MaBuffer2, 0, maPeriod2, 0, 0, Bars - shift - maPeriod2), shift);    

    return(indiUtils.getManualBuffer(MaBuffer3, shift));
}

double ma.maOnManualBuffer(double array[], int period, int maType, int shift) {
   int i = Bars - 1 - shift;
   return(ma.maOnArray(array, period, maType, i));
}

double ma.maOnArray(double array[], int period, int maType, int shift){
   switch(maType){
      case 0: 
         return(ma.SMAOnArray(array, period, shift)); 
         break;
      case 1: 
         return(0); 
         break;
      case 2: 
         return(0);  
         break;  
      case 3: 
         return(ma.LWMAonArray(array, period, shift));  
         break;
      case 4: 
         return(regression.LRMAOnArray(array, period, shift));  
         break;
      case 5: 
         return(regression.QRMAOnArray(array, period, shift));  
         break;
      default: 
         return(ma.SMAOnArray(array, period, shift)); 
         break;
   }
}

double ma.SMAOnArray(double array[], int per, int bar){
   double Sum = 0;
   for(int i = 0;i < per;i++) {
      Sum += array[bar-i];
   }
   return(Sum/per);
}                

double ma.LWMAonArray(double array[],int per,int bar){
   double Sum = 0;
   double Weight = 0;
   
   for(int i = 0;i < per;i++){ 
      Weight+= (per - i);
      Sum += array[bar-i]*(per - i);
   }
   if(Weight>0) {
      double lwma = Sum/Weight;
   } else {
      lwma = 0; 
   }
   return(lwma);
} 
double ma.qwmaOnArray(double &array[], int period, int shift) {
   double sum = 0;
   int j, i;
   for(j = shift,i = 1;j < shift + period; j++, i++ ) {
      sum += array[j] * MathPow(period - i + 1, 2);
   }
   double value = 6.0 / (period * ( period + 1) * (2 * period + 1)) ;
   return(value * sum);
}

double ma.qwma(int period, int price, int shift) {
   double sum = 0;
   int j, i;
   for(j = shift,i = 1;j < shift + period; j++, i++ ) {
      sum += switch.getPrice(price, j) * MathPow(period - i + 1, 2);
   }
   double value = 6.0 / (period * ( period + 1) * (2 * period + 1)) ;
   return(value * sum);
}


