//+------------------------------------------------------------------+
//|                                   Copyright  2012, Ivan Kornilov|
//|                                         indicators\Regression.mqh|
//|                                   excelf@gmail.com, skype: excelf|
//+------------------------------------------------------------------+

/*
#include <constants.mqh>
#include <switch.mqh>
#include <indicators\Ma.mqh>
#include <indicators\Regression.mqh>
//*/

double regression.getAngle(double &Line[], int shift,  int shiftAngle, double div) {
      if(Line[shift + shiftAngle] != 0) {
         return (MathArctan(( Line[shift] - Line[shift + shiftAngle] ) / shiftAngle / div) / PI * 2);
      } else {
         return (0);
      }
}

double regression.getRegression(int period, int degree, int price, int shift) {
   if(degree == 1) {
      return(regression.LRMA(period, price, shift));
   } else if(degree == 2) {
      return(regression.QRMA(period, price, shift));
   } else {
      return(regression.regressionPolynomial(period, degree, price, shift));
   }
}

double regression.getRegOnArray(double &array[], int period, int degree, int shift) {
      if(degree == 1) {
      return(regression.LRMAOnArray(array, period, shift));
   } else if(degree == 2) {
      return(regression.QRMAOnArray(array, period, shift));
   } else {
      return(regression.regressionOnArray(array, period, degree, shift));
   }
}

double regression.regressionOnArray(double &array[], int period, int degree,int shift) {
   //TODO
   return(0);
}

double a[10, 10];
double b[10];
double x[10];
double sx[20];
int n;
int i;
int k;
double t;
int degree1;

double regression.regressionPolynomial(int period, int degree, int priceCase, int shift) {
      sx[1] = period + 1;
      degree1 = degree + 1;
   
      for(i = 1;i <= degree1 * 2 - 2; i++) {
         sx[i+1] = 0;
         for(n = 0;n <= period; n++){
            sx[i+1] += MathPow(n, i);
         }
      }  
      double t;
      for(i = 1; i <= degree1; i++){
         b[i] = 0;
         for(n = 0; n <= period; n++){ 
            if(i == 1) {
               b[i] += switch.getPrice(priceCase, n + shift);
            } else {
               b[i] += switch.getPrice(priceCase, n + shift) * MathPow(n, i - 1);
            }
         }
      } 

      for(int j = 1;j <= degree1; j++){
         for(i = 1; i <= degree1; i++){
            k = i + j - 1;
            a[i, j] = sx[k];
         }
      }  

      for(k = 1; k <= degree1-1; k++){
         int l = 0;
         double mm = 0;
         for(i = k; i <= degree1; i++){
            if(MathAbs(a[i, k]) > mm){
               mm = MathAbs(a[i, k]);
               l = i;
            }
         }
         if(l == 0) {
            return(0);   
         }
         if (l != k){
            for(j = 1; j <= degree1; j++){
               t = a[k, j];
               a[k, j] = a[l, j];
               a[l, j] = t;
            }
            t = b[k];
            b[k] = b[l];
            b[l] = t;
         }  
         double div = 0;
         for(i = k + 1;i <= degree1; i++){
            div = a[i, k] / a[k, k];
            for(j = 1;j <= degree1; j++){
               if(j == k) {
                  a[i, j] = 0;
               } else { 
                  a[i, j] = a[i, j] - div * a[k, j];
               }
            }
            b[i] = b[i] - div * b[k];
         }
      }  
   
      x[degree1] = b[degree1] / a[degree1, degree1];
      for(i = degree;i >= 1; i--){
         t = 0;
         for(j = 1;j <= degree1 - i; j++){
            t = t + a[i, i + j] * x[i + j];
            x[i] = (1 / a[i, i]) * (b[i] - t);
         }
      } 

      double value = x[1];
      for(i = 1;k <= degree; i++){
         value += x[i + 1] * MathPow(n, i);
      }
      return (value);
}

double regression.getLinearValue(int period, int shift) {
   double sumx = 0;
   double sumy = 0;
   double sumxy = 0;
   double sumx2 = 0;
   double sumy2 = 0;
   for(int n = 0; n < period; n++){ 
      sumx = sumx + n;
      sumy = sumy + Close[shift + n];
      sumxy = sumxy + n * Close[shift + n];
      sumx2 = sumx2 + n * n;
      sumy2 = sumy2 + Close[shift + n] * Close[shift + n]; 
   }                      
   double b = (period * sumxy - sumx * sumy) / (period * sumx2 - sumx * sumx); 
   double a = (sumy + b * sumx) / period;
   return(a - b * period);
}

double regression.getLinearOnArray(double &array[], int period, int shift) {
   double sumx = 0;
   double sumy = 0;
   double sumxy = 0;
   double sumx2 = 0;
   double sumy2 = 0;
   for(int n = 0; n < period; n++){ 
      sumx = sumx + n;
      sumy = sumy + array[shift + n];
      sumxy = sumxy + n * array[shift + n];
      sumx2 = sumx2 + n * n;
      sumy2 = sumy2 + array[shift + n] * array[shift + n]; 
   }                      
   double b = (period * sumxy - sumx * sumy) / (period * sumx2 - sumx * sumx); 
   double a = (sumy + b * sumx) / period;
   return(a - b * period);
}

double regression.LRMA(int period, int price, int shift){     
      return(3.0 * iMA(NULL, 0, period, 0, MODE_LWMA, price, shift) - 2.0 * iMA(NULL, 0, period, 0, MODE_SMA, price, shift));
}
double regression.LRMAOnArray(double &array[], int period, int shift) {
   return(3 * ma.LWMAonArray(array, period, shift) - 2 * iMAOnArray(array, 0, period, 0, MODE_SMA, shift));
  // return(3 * ma.LWMAonArray(array, period, shift) - 2 * ma.SMAOnArray(array, period, shift));
}

double regression.QRMA(int period, int price, int shift) {
   double lwma = iMA(NULL, 0, period, 0, MODE_LWMA, price, shift);
   double sma = iMA(NULL, 0, period, 0, MODE_SMA, price, shift);
   double qwma = ma.qwma(period, price, shift);
   double value = 3.0 * sma + qwma * (10 - 15 / (period + 2 )) - lwma * (12 - 15 / (period + 2));
   return(value);
}

double regression.QRMAOnArray(double &array[], int period, int shift) {
   double lwma = ma.LWMAonArray(array, period, shift);
   double sma = iMAOnArray(array, 0, period, 0, MODE_SMA, shift);
   double qwma = ma.qwmaOnArray(array, period, shift);
   double value = 3.0 * sma + qwma * ( 10 - 15/( period + 2 ) ) - lwma * (12 - 15 / (period + 2));
   return(value);
}



